package cn.ibizlab.core.analysis.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.util.domain.EntityBase;
import cn.ibizlab.util.annotation.DEField;
import cn.ibizlab.util.enums.DEPredefinedFieldType;
import cn.ibizlab.util.enums.DEFieldDefaultValueType;
import cn.ibizlab.util.helper.DataObject;
import cn.ibizlab.util.enums.DupCheck;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import cn.ibizlab.util.annotation.Audit;


import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.baomidou.mybatisplus.annotation.*;
import cn.ibizlab.util.domain.EntityMP;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;

/**
 * 实体[图表]
 */
@Getter
@Setter
@NoArgsConstructor
@JsonIgnoreProperties(value = "handler")
@TableName(value = "IBZDACHART", resultMap = "DAChartResultMap")
public class DAChart extends EntityMP implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 标识
     */
    @DEField(isKeyField = true)
    @TableId(value = "chartid", type = IdType.ASSIGN_UUID)
    @JSONField(name = "chart_id")
    @JsonProperty("chart_id")
    private String chartId;
    /**
     * 名称
     */
    @TableField(value = "chartname")
    @JSONField(name = "chart_name")
    @JsonProperty("chart_name")
    private String chartName;
    /**
     * 过滤项字典
     */
    @TableField(value = "dict")
    @JSONField(name = "dict")
    @JsonProperty("dict")
    private String dict;
    /**
     * 分组
     */
    @DEField(name = "chartgroup")
    @TableField(value = "chartgroup")
    @JSONField(name = "group")
    @JsonProperty("group")
    private String group;
    /**
     * 展现配置
     */
    @DEField(name = "vmcfg")
    @TableField(value = "vmcfg")
    @JSONField(name = "config")
    @JsonProperty("config")
    private String config;



    /**
     * 设置 [名称]
     */
    public void setChartName(String chartName) {
        this.chartName = chartName;
        this.modify("chartname", chartName);
    }

    /**
     * 设置 [过滤项字典]
     */
    public void setDict(String dict) {
        this.dict = dict;
        this.modify("dict", dict);
    }

    /**
     * 设置 [分组]
     */
    public void setGroup(String group) {
        this.group = group;
        this.modify("chartgroup", group);
    }

    /**
     * 设置 [展现配置]
     */
    public void setConfig(String config) {
        this.config = config;
        this.modify("vmcfg", config);
    }


    /**
     * 复制当前对象数据到目标对象(粘贴重置)
     * @param targetEntity 目标数据对象
     * @param bIncEmpty  是否包括空值
     * @param <T>
     * @return
     */
    @Override
    public <T> T copyTo(T targetEntity, boolean bIncEmpty) {
        this.reset("chartid");
        return super.copyTo(targetEntity, bIncEmpty);
    }
}


