package cn.ibizlab.core.analysis.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.math.BigInteger;
import java.util.HashMap;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.util.ObjectUtils;
import org.springframework.util.DigestUtils;
import cn.ibizlab.util.domain.EntityBase;
import cn.ibizlab.util.annotation.DEField;
import cn.ibizlab.util.enums.DEPredefinedFieldType;
import cn.ibizlab.util.enums.DEFieldDefaultValueType;
import cn.ibizlab.util.helper.DataObject;
import cn.ibizlab.util.enums.DupCheck;
import java.io.Serializable;
import lombok.*;
import org.springframework.data.annotation.Transient;
import cn.ibizlab.util.annotation.Audit;


/**
 * [维度] 对象
 */
@Builder
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
public class DADimension extends EntityBase implements Serializable {

    /**
     * 维度标识
     */
    @DEField(name = "dimid", isKeyField = true)
    @JSONField(name = "id")
    @JsonProperty("id")
    private String id;

    /**
     * 维度名称
     */
    @DEField(name = "dimname")
    @JSONField(name = "name")
    @JsonProperty("name")
    private String name;

    /**
     * 属性名
     */
    @DEField(name = "fieldname")
    @JSONField(name = "field")
    @JsonProperty("field")
    private String field;

    /**
     * 字典
     */
    @JSONField(name = "dict")
    @JsonProperty("dict")
    private String dict;

    /**
     * Recursive
     */
    @DEField(defaultValue = "1")
    @JSONField(name = "recursive")
    @JsonProperty("recursive")
    private Integer recursive;

    /**
     * 分析标识
     */
    @JSONField(name = "buildId")
    @JsonProperty("buildId")
    private String buildid;


    /**
     * 构建
     */
    @JSONField(name = "build")
    @JsonProperty("build")
    private cn.ibizlab.core.analysis.domain.DABuild build;



}


